------------------------------------------------------------------
--Ejercicio 1. Escribir una funcin recursiva de pila que sume todos los numeros menores de 3 que aparezcan en una lista de enteros
------------------------------------------------------------------
summenor3 :: [Integer] -> Integer
summenor3 [] = 0
summenor3 (front:rest)= if front < 3 then front + summenor3 rest else summenor3 rest


------------------------------------------------------------------
--Ejercicio 2. Escribir una funcin recursiva acumulativa que calcule el mximo elemento de la lista.
------------------------------------------------------------------
maximoentero :: ([Integer], Integer) -> Integer
maximoentero ([], max) = max
maximoentero (front:rest, max) = if front > max then maximoentero(rest, front) else maximoentero(rest, max)

maximo :: [Integer] -> Integer
maximo lista = maximoentero(lista, 0)


------------------------------------------------------------------
--Ejercicio 3.Crear una funcin que convierta una cadena ("1234") a un entero (1234). Crear una funcin que convierta un entero a una cadena.
------------------------------------------------------------------
c2i '0' = 0
c2i '1' = 1
c2i '2' = 2
c2i '3' = 3
c2i '4' = 4
c2i '5' = 5
c2i '6' = 6
c2i '7' = 7
c2i '8' = 8
c2i '9' = 9
convert :: String -> Int
convert [] = 0
convert (front:rest) = ((10 ^ (length rest)) * c2i front) + convert rest


------------------------------------------------------------------
--Ejercicio 4. Crear una funcin listar_enteros (n,lista) que devuelva una lista con los enteros comprendidos entre 0 y n.
------------------------------------------------------------------
listar_enteros :: (Integer, [Integer]) -> [Integer]
listar_enteros (n, lista) = if n>0 then n:listar_enteros (n-1, n:lista) else [n]
-- Llamar asi: listar_enteros(5, [])


------------------------------------------------------------------
--Ejercicio 5. Crear una funcin listar_entre(inicio,fin,lista,acc) que devuelva una lista formada por los enteros entre inicio y fin.
------------------------------------------------------------------
listar_entre :: (Integer,Integer, [Integer]) -> [Integer]
listar_entre (inicio, fin, lista) = if inicio <= fin then listar_entre(inicio+1, fin, inicio:lista) else lista
-- Llamar asi:  listar_entre(1, 7, [])
-- (!!) Para que el acc del enunciado??


------------------------------------------------------------------
--Ejercicio 6. Modificar el ejercicio 5 para que solo muestre los mltiplos de 2.
------------------------------------------------------------------
listar_entre2 :: (Integer,Integer, [Integer]) -> [Integer]
listar_entre2 (inicio, fin, lista) = if inicio <= fin then listar_entre2(inicio+1, fin, if (inicio `mod` 2) == 0 then inicio:lista else lista) else lista
-- Si corregimos ejercicio 5, hay que modificar este tambien!!


------------------------------------------------------------------
--Ejercicio 7. Crear el tipo de datos coche, cuyos tipos de datos sern la marca y el precio. Hacer una funcin que acepte dos coches y nos diga cual es ms caro.
------------------------------------------------------------------
-- Tipo: (String, Integer)
data Coche = Coche(String, Integer) deriving (Eq, Show)
barato :: (Coche, Coche) -> String
barato (Coche(c1, p1),Coche(c2,p2)) = if p1<p2 then c1 else c2


------------------------------------------------------------------
--Ejercicio 8. Probar la funcin con un arbol creado por nosotros:
--Ejemplo:
--   3
--  4 5
--6 7 8 9
------------------------------------------------------------------

data Arbol a = Planta ((Arbol a),a, (Arbol a)) | Anil deriving (Eq, Show)

tree2list Anil = []
tree2list (Planta(a,b,c)) = tree2list a++[b]++tree2list c 

-- Para probarlo:
-- tree2list (Planta(Planta(Planta(Anil, 6, Anil), 4, Planta(Anil, 7, Anil)), 3, Planta(Planta(Anil, 8, Anil), 5, Planta(Anil, 9, Anil))))


------------------------------------------------------------------
-- Ejercicio 9. Escribir una funcin que calcule el mximo elemento de un arbol.
------------------------------------------------------------------
maxTree (Planta(Anil, b, Anil)) = b
maxTree (Planta(a, b, c)) | b > maxTree (a) && b > maxTree(c) = b
                          | maxTree(a) > maxTree(c) = maxTree(a)
                          | otherwise = maxTree(c)
-- Para provar:
--   3
--  4 10
--6 7 8 9
--maxTree(Planta(Planta(Planta(Anil, 6, Anil), 4, Planta(Anil, 7, Anil)), 3, Planta(Planta(Anil, 8, Anil), 10, Planta(Anil, 9, Anil))))


------------------------------------------------------------------
--Ejercicio 10. Escribir una funcin que nos indique si un elemento pertenece a un arbol.
------------------------------------------------------------------
pertenece (x, Planta(Anil, b, Anil)) | x==b = True
                                     | otherwise = False
pertenece (x, Planta(a, b, c)) | x==b = True
                               | pertenece (x, a) = True
                               | pertenece (x, c) = True
                               | otherwise = False

-- Para provar:
--   3
--  4 10
--6 7 8 9
--pertenece(6, Planta(Planta(Planta(Anil, 6, Anil), 4, Planta(Anil, 7, Anil)), 3, Planta(Planta(Anil, 8, Anil), 10, Planta(Anil, 9, Anil))))


------------------------------------------------------------------
--Ejercicio 11. Escribir una funcin que calcule la suma de los elementos de un arbol.
------------------------------------------------------------------

sumaTree (Planta(Anil, b, Anil)) = b
sumaTree (Planta(a,b,c)) = sumaTree(a) + b + sumaTree(c)

-- Para provar:
--   3
--  4 10
--6 7 8 9  = 47
--sumaTree(Planta(Planta(Planta(Anil, 6, Anil), 4, Planta(Anil, 7, Anil)), 3, Planta(Planta(Anil, 8, Anil), 10, Planta(Anil, 9, Anil))))


------------------------------------------------------------------
--Ejercicio 12. Escribir una funcin que calcule la altura de un rbol.
------------------------------------------------------------------

altura (Planta(Anil, b, Anil)) = 1
altura (Planta(a, b, c)) = if altura(a) > altura(c) then altura(a)+1 else altura(c)+1

-- Para provar:
--   3
--  4 10
--6 7 8 9
--altura(Planta(Planta(Planta(Anil, 6, Anil), 4, Planta(Anil, 7, Anil)), 3, Planta(Planta(Anil, 8, Anil), 10, Planta(Anil, 9, Anil))))


------------------------------------------------------------------
--Ejercicio 13. Implementar la funcin power (n,b) que eleva n a b y utilizar funciones de alto nivel para calcular la funcin cubo.
--power:: (Integer, Integer) -> Integer
------------------------------------------------------------------
power 0 n = 1
power b n = n * power (b-1) n

cubo = power 2


------------------------------------------------------------------
--Ejercicio 14.
--Probar la funcin map con diferentes funciones: incrementar en uno, multiplicar por 2, ...
--Crear la funcin de alto nivel map_inc que parametrice parcialmente map.
------------------------------------------------------------------

inc n = n+1
por_dos n = n*2

map2 f [] = []
map2 f (x:xs) = f x:map2 f xs

map_inc = map2 inc
map_dos = map2 por_dos

-- Para probar:
-- map_inc [2,3,4]
-- map_dos [2,3,4] 


------------------------------------------------------------------
--Ejercicio 15.
--Utilizando la solucin del ejercicio 5, modificarlo para que la funcion acepte una funcin como parametro.
--Queremos que se aplique esta funcin sobre cada uno de los elementos entre inicio y fin que se almacenarn en la lista final.
------------------------------------------------------------------
--Pistas: Esta funcin aceptar un entero y devolver un entero. Ejemplo : fun incr x = x+1; Para pasarla como parmetro
--escribiremos (nombrefuncion:int->int).

-- La definicion no funciona, no se como hacerla, aunque tampoco estoy seguro de que sea necesaria (funciona sin ella).
--listar_entre5 :: (Integer,Integer, [Integer], (func:Integer->Integer)) -> [Integer]
listar_entre15 (inicio, fin, lista, func) = if inicio <= fin then listar_entre15(inicio+1, fin, func inicio:lista, func) else lista

-- Para probar:
--listar_entre5(4, 10, [], por_dos) 


------------------------------------------------------------------
--Ejercicio 16. Implementar una funcin de alto nivel llamada filter, que acepte dos parmetros , el primero ser una funcin con un 
-- parmetro polimrfico que devolver un valor booleano, el segundo ser una lista polimrfica. La funcin filter devolver una lista 
-- formada por los elementos de la lista original cuyos elementos cumplan el predicado establecido por la funcin.
------------------------------------------------------------------

filter2 func [] = []
filter2 func (x:xs) | func x = x:filter2 func xs
                   | otherwise = filter2 func xs

islessthan n b = b<n

-- Para probar:
--filter2 (islessthan 3) [1,7,2,9,67,3]


------------------------------------------------------------------
-- Ejercicio 17. Implementar las funciones filter y map con listas intensionales.
------------------------------------------------------------------

map3 f [] = []
map3 f (x:xs) = f x:map3 f xs

filter3 p [] = []
filter3 p (x:xs) | p x = x:filter3 p xs
                | otherwise = filter3 p xs

                
------------------------------------------------------------------
--Ejercicio 18. c) Implementa las funciones concatenar_listas, longitud, y sum_list parametrizando parcialmente la funcin foldr.
------------------------------------------------------------------

foldr2 :: (a -> b -> b) -> b -> [a] -> b
foldr2 f z [] = z
foldr2 f z (x:xs) = f x (foldr2 f z xs)

concatenar x y = x:y
concatenar_listas = foldr2 concatenar

contar x y = 1 + y
longitud = foldr2 contar 0

suma x y = x + y
sum_list = foldr2 suma 0


------------------------------------------------------------------
-- Ejercicio 19.  que hacen las funciones siguientes ? Explicalas con ejemplos. Muestra un ejemplo de parametrizacin parcial sobre 
-- alguna de ellas.
------------------------------------------------------------------

-- Coge los n primeros elementos de una lista
take2 :: Int -> [a] -> [a]
take2 n _ | n <= 0 = []
take2 _ [] = []
take2 n (x:xs) = x : take2 (n-1) xs

-- Probar con:
-- take2 2 [1,2,3,4]
-- Resultado: [1,2]

-- Descarta los n primero elementos de una lista, quedandose con el resto
drop2 :: Int -> [a] -> [a]
drop2 n xs | n <= 0 = xs
drop2 _ [] = []
drop2 n (_:xs) = drop2 (n-1) xs

-- Probar con:
-- drop2 2 [1,2,3,4]
-- Resultado: [3,4]

-- Va cogiendo elementos mientras cumplen 1 condicion, en cuanto la condicion
-- es falsa deja de coger.
takeWhile2 :: (a -> Bool) -> [a] -> [a]
takeWhile2 p [] = []
takeWhile2 p (x:xs) | p x = x : takeWhile2 p xs
                    | otherwise = []

-- Probar con: (islessthan esta definido en un ejercicio anterior)
-- takeWhile2 (islessthan 10) [1,2,3,12,3,44]
-- Resultado [1,2,3]

-- Va descartando elementos mientras cumplen 1 condicion, en cuanto la condicion
-- es falsa deja de descartar.
dropWhile2 :: (a -> Bool) -> [a] -> [a]
dropWhile2 p [] = []
dropWhile2 p xs@(x:xs') | p x = dropWhile2 p xs'
                        | otherwise = xs
-- Probar con: (islessthan esta definido en un ejercicio anterior)
-- dropWhile2 (islessthan 10) [1,2,3,12,3,44]
-- Resultado [12,3,44]

-- Ejemplo de parametrizacion parcial:
takeLessthan10 = takeWhile2 (islessthan 10)

